﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGComboEditorCellClickCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel VM = new ViewModel();
        ObservableCollection<string> FoodTypes = new ObservableCollection<string>();
        ObservableCollection<double> Prices = new ObservableCollection<double>();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = VM;
            for (int i = 0; i < VM.Data.Count; i++)
            {
                FoodTypes.Add(VM.Data[i].FoodType);
                Prices.Add(VM.Data[i].Price);
            }
        }

        CellValuePresenter CVP = new CellValuePresenter();     

        void CVP_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            CVP = ((CellValuePresenter)sender);
           
            Style s = new Style(typeof(CellValuePresenter));

            Trigger T = new Trigger();

            T.Property = CellValuePresenter.IsInEditModeProperty;
            T.Value = true;
            
            ControlTemplate CT = new ControlTemplate(typeof(CellValuePresenter));

            Binding A = new Binding();
            A.Source = FoodTypes;

            Binding B = new Binding();
            B.Source = Prices;
           
            Binding C = new Binding("FoodType");
            C.Source = ((FoodClass)CVP.Record.DataItem);
            
            Binding D = new Binding("Price");
            D.Source = ((FoodClass)CVP.Record.DataItem);            

            var XCE = new FrameworkElementFactory(typeof(XamComboEditor));
                       
            if (CVP.Field.Name.ToString() == "FoodType")
            {
                XCE.SetBinding(XamComboEditor.ItemsSourceProperty, A);
                XCE.SetBinding(XamComboEditor.SelectedItemProperty, C);
            }
            else
            {
                XCE.SetBinding(XamComboEditor.ItemsSourceProperty, B);
                XCE.SetBinding(XamComboEditor.SelectedItemProperty, D);
            }
                        
            CT.VisualTree = XCE;

            T.Setters.Add(new Setter(CellValuePresenter.TemplateProperty, CT));

            s.Triggers.Add(T);

            CVP.Style = s;            
        }
    }
}
