﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGComboEditorCellClickCase
{
    class ViewModel
    {
        public ObservableCollection<FoodClass> Data { get; set; }
        public string[] foods = { "Seafood", "Meat", "Vegetables", "Fruit", "Various Munchies" };
        public double[] price = { 1.99, 2.99, 3.99, 4.99, 5.99 };

        public ViewModel()
        {
            Data = new ObservableCollection<FoodClass>();
            for (int i = 0; i < foods.Length; i++)
            {
                Data.Add(new FoodClass
                {
                    FoodType = foods[i],
                    Price = price[i]
                });
            }
        }
    }

    public class FoodClass : INotifyPropertyChanged
    {
        private string food;
        private double p;
        public string FoodType
        {
            get { return food; }
            set
            {
                if (food != value)
                {
                    food = value;
                    OnPropertyChanged("FoodType");
                }
            }
        }
        public double Price
        {
            get { return p; }
            set
            {
                if (p != value)
                {
                    p = value;
                    OnPropertyChanged("Price");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
